<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/Object.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Object.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Object_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef Object_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define Object_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="classObject.html">   10</a></span>&#160;<span class="keyword">class </span><a class="code" href="classObject.html">Object</a>{</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <a class="code" href="classObject.html#a40860402e64d8008fb42329df7097cdb">Object</a>();</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classObject.html#ad644b8a35c64ade4e15b3e33a2a5d77f">GetX</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classObject.html#a65d30f9f3b22ed328cb24482ed4ba896">GetY</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classObject.html#ab04c46e902c454a25751f900948d6d5e">ForcedRender</a>();</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classObject.html#a2199afbf2f52ff746c4c871e434ff20f">Render</a>();</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classObject.html#a5b25442efcce1e5768e3790b36accd1a">Clear</a>();    </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classObject.html#a6cac457fe1568b09a7f510654245972e">SetSprite</a>(<span class="keyword">const</span> std::string &amp; spr);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classObject.html#a209e2a1b3e3a30a11d1d8595a0147ffb">SetXY</a>(<span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classObject.html#a5ee5c17a09981cbd7c469370e210b4ff">Update</a>() = 0;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classObject.html#adc113651aab71178e254d7d7f3b1e53b">Destroy</a>();</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classObject.html#ae0e2dd4a28a6327bad26b43e8101e1d9">isMarked</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classObject.html#a20bdbcf7662f94b783461df61f1dead2">   68</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classObject.html#a20bdbcf7662f94b783461df61f1dead2">m_MarkForDestruction</a>; </div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="classObject.html#aa080149410482bbf134f663f0eec478a">   69</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classObject.html#aa080149410482bbf134f663f0eec478a">m_PositionChanged</a>; </div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classObject.html#a1e33bf8f94303c821e0036975f1f9e44">   70</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classObject.html#a995c8304abf2e3fd8fb29b59ab1048cc">m_X</a>, <a class="code" href="classObject.html#a1e33bf8f94303c821e0036975f1f9e44">m_Y</a>;</div>
<div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="classObject.html#ab3f832ee25ca13bad87645c44c7019e3">   71</a></span>&#160;    std::string <a class="code" href="classObject.html#ab3f832ee25ca13bad87645c44c7019e3">m_Sprite</a>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;};</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* Object_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassObject_html_a5ee5c17a09981cbd7c469370e210b4ff"><div class="ttname"><a href="classObject.html#a5ee5c17a09981cbd7c469370e210b4ff">Object::Update</a></div><div class="ttdeci">virtual void Update()=0</div><div class="ttdoc">Pure virtual Update function that is used in GameScene's game loop.</div></div>
<div class="ttc" id="aclassObject_html_adc113651aab71178e254d7d7f3b1e53b"><div class="ttname"><a href="classObject.html#adc113651aab71178e254d7d7f3b1e53b">Object::Destroy</a></div><div class="ttdeci">void Destroy()</div><div class="ttdoc">Marks Object for destruction and garbage collection by GameScene.</div><div class="ttdef"><b>Definition:</b> Object.cpp:100</div></div>
<div class="ttc" id="aclassObject_html_a1e33bf8f94303c821e0036975f1f9e44"><div class="ttname"><a href="classObject.html#a1e33bf8f94303c821e0036975f1f9e44">Object::m_Y</a></div><div class="ttdeci">int m_Y</div><div class="ttdef"><b>Definition:</b> Object.h:70</div></div>
<div class="ttc" id="aclassObject_html_a209e2a1b3e3a30a11d1d8595a0147ffb"><div class="ttname"><a href="classObject.html#a209e2a1b3e3a30a11d1d8595a0147ffb">Object::SetXY</a></div><div class="ttdeci">void SetXY(int x, int y)</div><div class="ttdoc">Sets position of Object.</div><div class="ttdef"><b>Definition:</b> Object.cpp:94</div></div>
<div class="ttc" id="aclassObject_html_a995c8304abf2e3fd8fb29b59ab1048cc"><div class="ttname"><a href="classObject.html#a995c8304abf2e3fd8fb29b59ab1048cc">Object::m_X</a></div><div class="ttdeci">int m_X</div><div class="ttdef"><b>Definition:</b> Object.h:70</div></div>
<div class="ttc" id="aclassObject_html"><div class="ttname"><a href="classObject.html">Object</a></div><div class="ttdoc">Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...</div><div class="ttdef"><b>Definition:</b> Object.h:10</div></div>
<div class="ttc" id="aclassObject_html_aa080149410482bbf134f663f0eec478a"><div class="ttname"><a href="classObject.html#aa080149410482bbf134f663f0eec478a">Object::m_PositionChanged</a></div><div class="ttdeci">bool m_PositionChanged</div><div class="ttdef"><b>Definition:</b> Object.h:69</div></div>
<div class="ttc" id="aclassObject_html_a40860402e64d8008fb42329df7097cdb"><div class="ttname"><a href="classObject.html#a40860402e64d8008fb42329df7097cdb">Object::Object</a></div><div class="ttdeci">Object()</div><div class="ttdoc">Construct a new Object and initializes internal variables.</div><div class="ttdef"><b>Definition:</b> Object.cpp:6</div></div>
<div class="ttc" id="aclassObject_html_a20bdbcf7662f94b783461df61f1dead2"><div class="ttname"><a href="classObject.html#a20bdbcf7662f94b783461df61f1dead2">Object::m_MarkForDestruction</a></div><div class="ttdeci">bool m_MarkForDestruction</div><div class="ttdef"><b>Definition:</b> Object.h:68</div></div>
<div class="ttc" id="aclassObject_html_a65d30f9f3b22ed328cb24482ed4ba896"><div class="ttname"><a href="classObject.html#a65d30f9f3b22ed328cb24482ed4ba896">Object::GetY</a></div><div class="ttdeci">int GetY() const</div><div class="ttdef"><b>Definition:</b> Object.cpp:15</div></div>
<div class="ttc" id="aclassObject_html_a6cac457fe1568b09a7f510654245972e"><div class="ttname"><a href="classObject.html#a6cac457fe1568b09a7f510654245972e">Object::SetSprite</a></div><div class="ttdeci">void SetSprite(const std::string &amp;spr)</div><div class="ttdoc">Sets sprite for later rendering of Object.</div><div class="ttdef"><b>Definition:</b> Object.cpp:90</div></div>
<div class="ttc" id="aclassObject_html_ab04c46e902c454a25751f900948d6d5e"><div class="ttname"><a href="classObject.html#ab04c46e902c454a25751f900948d6d5e">Object::ForcedRender</a></div><div class="ttdeci">void ForcedRender()</div><div class="ttdoc">Forces Object to render even if position didnt changed.</div><div class="ttdef"><b>Definition:</b> Object.cpp:20</div></div>
<div class="ttc" id="aclassObject_html_ad644b8a35c64ade4e15b3e33a2a5d77f"><div class="ttname"><a href="classObject.html#ad644b8a35c64ade4e15b3e33a2a5d77f">Object::GetX</a></div><div class="ttdeci">int GetX() const</div><div class="ttdef"><b>Definition:</b> Object.cpp:11</div></div>
<div class="ttc" id="aclassObject_html_ab3f832ee25ca13bad87645c44c7019e3"><div class="ttname"><a href="classObject.html#ab3f832ee25ca13bad87645c44c7019e3">Object::m_Sprite</a></div><div class="ttdeci">std::string m_Sprite</div><div class="ttdef"><b>Definition:</b> Object.h:71</div></div>
<div class="ttc" id="aclassObject_html_a2199afbf2f52ff746c4c871e434ff20f"><div class="ttname"><a href="classObject.html#a2199afbf2f52ff746c4c871e434ff20f">Object::Render</a></div><div class="ttdeci">void Render()</div><div class="ttdoc">Displays Object to ncurses stdscr.</div><div class="ttdef"><b>Definition:</b> Object.cpp:24</div></div>
<div class="ttc" id="aclassObject_html_ae0e2dd4a28a6327bad26b43e8101e1d9"><div class="ttname"><a href="classObject.html#ae0e2dd4a28a6327bad26b43e8101e1d9">Object::isMarked</a></div><div class="ttdeci">bool isMarked() const</div><div class="ttdef"><b>Definition:</b> Object.cpp:105</div></div>
<div class="ttc" id="aclassObject_html_a5b25442efcce1e5768e3790b36accd1a"><div class="ttname"><a href="classObject.html#a5b25442efcce1e5768e3790b36accd1a">Object::Clear</a></div><div class="ttdeci">void Clear()</div><div class="ttdoc">Clears sprite that is being displayed to stdscr.</div><div class="ttdef"><b>Definition:</b> Object.cpp:59</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
